import java.util.Arrays;

/*
 * Sort Class - abstract parent class which defines the minimum requirements
 * to be a sort.  Subclasses must inherit from and implement the abstract methods below. 
 * Look in the main driver for example usage for your sorts.  Start by building a 
 * Bubble Sort, and comment out other Quick Sort code below to test your
 * first sort class independently before moving on to the more complex
 * Quick Sort subclass.
 * 
 * Author: Rob Nash
 * 
 */

public abstract class Sort {


	protected abstract void sort(Comparable[] data, int first, int last); // [first,...,last]

	protected void swap(Comparable[] data, int idx1, int idx2) {
		Comparable temp = data[idx1];
		data[idx1] = data[idx2];
		data[idx2] = temp;
	}

	// Don't make changes to the code below. What does the final modifier do?
	private int comparisons = 0;

	public final int getComparisons() {
		return comparisons;
	}

	public final void resetComparisons() {
		comparisons = 0;
	}

	public final void incrementComparisons() {
		comparisons++;
	}
}
