import java.awt.BasicStroke;
import java.awt.Graphics;
import java.awt.Graphics2D;



/*Square class, I need to rename this to rectangle
A shape subclass that holds the dimenstions for a rectangle

Danny Nguyen
*/
public class Square extends Shape {
	private int width;
	private int height;

	//Main Constructor
	//takes the first 2 ints for XY coordinates
	//last 2 ints for width and height
	public Square(int x, int y, int w, int h) {
		super(x, y);
		if(w<0||h<0) throw new JavaPaintException("Negative width/height");
		setW(w);
		setH(h);
	}

	//copy constructor
	public Square(Square o) {
		super(o.getX(), o.getY());
		setStroke(o.getStroke());
		setFill(o.getFill());
		setW(o.getW());
		setH(o.getH());
		setRGB(o.getRGB());
	}

	//Width getter and setter
	public int getW(){
		return width;
	}
	public void setW(int dw) {
		if(dw>=0) width=dw;
	}

	//Height getter and setter
	public int getH(){
		return height;
	}
	public void setH(int dh) {
		if(dh>=0) height=dh;
	}

	//makes this rectangle into a square
	@Override
	public void setSize(int d) {
		setH(d);
		setW(d);
	}

	@Override
	public double getArea() {
		return width*height;//area of a rectangle... need i say more?
	}

	@Override
	//drawing rectangles
	public void draw(Graphics g) {
		Graphics2D g2d=(Graphics2D) g;
		g2d.setStroke(new BasicStroke(getStroke()));//gets stroke from super
		g2d.setColor(getRGB());//gets color from super
		if(getFill())g2d.fillRect(getX(), getY(), width, height);
		else g2d.drawRect(getX(), getY(), width, height);
	}
	@Override
	public Shape clone() {
		return new Square(this);
	}
	@Override
	//Comparing Shapes
	//smaller shapes are +1
	//larger shapes are -1
	public int compareTo(Object o) {
		int retval=0;//default comparison
		if(o==null || !(o instanceof Shape)) {//checks if objects can be compared
			throw new JavaPaintException("Object not comparable to square");
		}

		//casts the object to be compared to a shape
		//since each shape calculates area differently
		Shape that;
		if(o instanceof Square) {
			that=(Square) o;
		}else if(o instanceof Circle){
			that=(Circle) o;
		}else that=(Line) o;

		if(this.getArea()==that.getArea()) {//shapes are equal
			retval=0;
		} else if(this.getArea()<that.getArea()) {//this  is smaller
			retval=1;
		} else {
			retval=-1;//the other square is smaller
		}
		return retval;
	}

}
