/*
 * Danny Nguyen
 * Creates and manages a stack list
 */
public class StackArray<tba extends Comparable> {
	private Comparable[] Stack = new Comparable[10];//holds comparable data
	private int numElements = 0;//number of elements

	public StackArray() {
	}

	// adds an object at numElements
	// then iterates numElements
	public void push(tba o) {
		if (o == null) // function does nothing if handed null
			return;
		if (numElements == Stack.length)// increases Stack[] size if needed
			reSize(numElements + 10);
		Stack[numElements++] = o;
	}

	// returns an object from Stack[] at numElements-1
	public tba pop() {
		if (numElements <= 0) throw new JavaPaintException("no more previous actions");
			if (numElements < Stack.length - 10)// decreases Stack[] size if needed
				reSize(numElements);
			return (tba) Stack[--numElements];
	}

	// checks if the stack is empty
	public boolean isEmpty() {
		return numElements == 0;
	}

	// returns number of elements in the stack
	public int size() {
		return numElements;
	}

	public String toString() {
		String retVal = "";
		for (int i = 0; i < numElements; i++) {
			retVal += Stack[i] + " ";
		}
		// substring to cut null and final space being spelled
		return retVal.substring(4, retVal.length() - 1);
	}

	// resizes Stack to fit more objects or shrinks to save memory
	private void reSize(int newSize) {
		Comparable[] temp = new Comparable[newSize];// creates a new temp array
		for (int i = 0; i < numElements; i++) {
			temp[i] = Stack[i]; // copies data from Stack to temp
		}
		Stack = temp; // assign temp to Stack
	}
}
